unit UDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MemPort, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MemPort1: TMemPort;
    EditAddress: TEdit;
    LabelAddress: TLabel;
    LabelLength: TLabel;
    EditLength: TEdit;
    SpeedButtonShowPhysicalMemory: TSpeedButton;
    procedure SpeedButtonShowPhysicalMemoryClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpeedButtonShowPhysicalMemoryClick(Sender: TObject);
  function GetChar(Value: Char): Char;
  begin
    if Value < ' ' then
      Result := '.'
    else
      Result := Value;
  end;
var
  Line, Row, LineCount: Integer;
  LineStr: String;
begin
  with MemPort1, Memo1 do
  try
    Screen.Cursor := crHourGlass;

    Clear;
    Lines.BeginUpdate;

    Close;
    Address := StrToInt(EditAddress.Text);
    Length := StrToInt(EditLength.Text);
    Open;

    LineCount := Length div 16;
    if Length mod 16 > 0 then
      Inc(LineCount);

    for Line := 0 to LineCount - 1 do
    begin
      LineStr := IntToHex(Address + Line * 16, 8) + ' ';
      for Row := 0 to 15 do
        LineStr := LineStr + IntToHex(Byte(Memory[Line * 16 + Row]), 2) + ' ';
      for Row := 0 to 15 do
        LineStr := LineStr + GetChar(Memory[Line * 16 + Row]);
      Memo1.Lines.Add(LineStr);
    end;

  finally
    Lines.EndUpdate;
    Screen.Cursor := crDefault;
  end;
end;

end.
